;(function() {
  var bd_global = typeof window !== 'undefined'
      ? window : typeof bd_global !== 'undefined' ? bd_global : typeof self !== 'undefined' ? self : {};
    
  function guid() {
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
      var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
      return v.toString(16);
    });
  }
  var currentNaviID = guid();
  function needReport(params) {
    if (window.location.href === 'about:blank') {
      return false;
    }
    return true;
  }
  
  function jsIESLiveTimingMonitorCover(params, service) {
    if (!needReport(params)) {
      return
    }
    params.serviceType = service
    if (window.webkit) {
      window.webkit.messageHandlers.iesLiveTimingMonitorCover.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorCover) {
      iesLiveTimingMonitorCover(formatMonitorParams(params));
    }
  }

  function jsIESLiveTimingMonitorAccumulate(params, service) {
    if (!needReport(params)) {
      return
    }
    params.serviceType = service
    if (window.webkit) {
      window.webkit.messageHandlers.iesLiveTimingMonitorAccumulate.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorAccumulate) {
      iesLiveTimingMonitorAccumulate(formatMonitorParams(params));
    }
  }

  function jsIESLiveTimingMonitorReportDirectly(params, service) {
    if (!needReport(params)) {
      return
    }
    params.serviceType = service
    if (window.webkit) {
      window.webkit.messageHandlers.iesLiveTimingMonitorReportDirectly.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorReportDirectly) {
      iesLiveTimingMonitorReportDirectly(formatMonitorParams(params));
    }
  }

  function jsIESLiveTimingMonitorAverage(params, service) {
    if (!needReport(params)) {
      return
    }
    params.serviceType = service
    if (window.webkit) {
      window.webkit.messageHandlers.iesLiveTimingMonitorAverage.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorAverage) {
      iesLiveTimingMonitorAverage(formatMonitorParams(params));
    }
  }

  function jsIESLiveTimingMonitorReportCustom(event_name, params) {
    if (typeof event_name === 'object') {
      params = event_name
      event_name = params && params.eventName
    }

    if (!needReport(params)) {
      return
    }
    var extra = typeof params.extra !== 'undefined' ? params.extra : {}
    extra['event_name'] = event_name
    params['extra'] = extra;
    if (window.webkit) {
      window.webkit.messageHandlers.iesLiveTimingMonitorReportCustom.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorReportCustom) {
      iesLiveTimingMonitorReportCustom(formatMonitorParams(params));
    }
  }

  function jsIESLiveTimingMonitorReportStage(params, service) {
    if (!needReport(params)) {
      return
    }
    params.serviceType = service
    if (window.webkit) {
      window.webkit.messageHandlers.iesLiveTimingMonitorReportStage.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorReportStage) {
      iesLiveTimingMonitorReportStage(formatMonitorParams(params));
    }
  }

  function formatMonitorParams(params) {
      if (!params) return params;
      if (!params.nativeBase) params.nativeBase = {};
    
      if (window.history.length <= 1) {
          params.nativeBase.firstPage = true
      }
      
      params.nativeBase.url = window.location.href
      params.nativeBase.navigation_id = currentNaviID
    return JSON.parse(JSON.stringify(params))
  }

  function jsIESLiveCalculateInitTime(jsDuration) {
    if (!needReport([jsDuration])) {
      return
    }
    var urlStr = window.location.href;
    var body = {url:urlStr, duration:jsDuration}
    if (window.webkit) {
      window.webkit.messageHandlers.iesLiveCalculateInitTime.postMessage(body);
    } else if (window.iesLiveCalculateInitTime) {
      iesLiveCalculateInitTime(body);
    }
  }

  function onDomContentLoaded() {
    var msg = {}
    msg.stage = 'DomContentLoaded';
    jsIESLiveTimingMonitorReportStage(msg, 'pv')
    window.setTimeout(function() {
      if (window.history.length <= 1) {
        jsIESLiveCalculateInitTime(performance.now());
      }
    }, 0)
  }

  function setPaintTiming(name, timestamp) {
    var navigationStart = bd_global.performance.timing.navigationStart;
    var entries = bd_global.bdPerformance.paintEntries;
    var found = false;
    if (navigationStart > 0 && timestamp > navigationStart) {
      var duration = timestamp - navigationStart;
      for (item of entries) {
        if (item.name == name) {
          item.startTime = duration;
          found = true;
        }
      }

      if (!found) {
        entries.push({name: name, entryType: 'paint', startTime: duration, duration: 0});
      }
    }
  }


  var bridge = {}
  bridge.cover = jsIESLiveTimingMonitorCover
  bridge.accumulate = jsIESLiveTimingMonitorAccumulate
  bridge.reportDirectly = jsIESLiveTimingMonitorReportDirectly
  bridge.average = jsIESLiveTimingMonitorAverage
  bridge.customReport = jsIESLiveTimingMonitorReportCustom

  bd_global.jsIESLiveTimingMonitor = bridge
  if (bd_global.SlardarHybrid) {
    bd_global.SlardarHybrid('config', {
      bid: '',
      transport: bd_global.jsIESLiveTimingMonitor,
      hookXHR: true,
      hookFetch: true,
      enablePerformance: true,
      enableFMP: true,
      enableStaticError: true,
      enableMemoryRecord: true,
      enableBreadcrumb: true,
      enableCatchJSError: true,
      enableFPSJankTimesMonitor: true
    })
  }
  
  var publicBridge = {}
  publicBridge.customReport = jsIESLiveTimingMonitorReportCustom
  bd_global.jsIESWebViewMonitor = publicBridge
  if (bd_global.bdPerformance === undefined || bd_global.bdPerformance === null) {
    bd_global.bdPerformance = {
      paintEntries : [],
      setFirstPaintTiming: function (timestamp) {
        setPaintTiming('first-paint', timestamp)
        setPaintTiming('first-contentful-paint', timestamp)
      },
      setFirstMeaningfulPaintTiming: function (timestamp) {
        setPaintTiming('first-meaningful-paint', timestamp)
      }
    }
  }

  if (bd_global.performance && !bd_global.bdPerformance.oriGetEntriesByType) {
    var getEntriesByType = bd_global.performance.getEntriesByType;
    bd_global.bdPerformance.oriGetEntriesByType = getEntriesByType;
    bd_global.performance.getEntriesByType = function(type) {
      if (typeof getEntriesByType !== 'function') {
        return [];
      }
      var result = getEntriesByType.call(bd_global.performance, type);

      if (typeof type == 'string' && type == 'paint' && !result.length) {
        result = bd_global.bdPerformance.paintEntries;
      }

      return result;
    }
  }
  
    var urlStr = window.location.href;
    var js_inject_msg = {url:urlStr, inject_js_time:Date.parse(new Date())}
    if (window.webkit) {
      window.webkit.messageHandlers.iesLiveTimingMonitorInjectJsTime.postMessage(js_inject_msg);
    } else if (window.iesLiveTimingMonitorInjectJsTime) {
      iesLiveTimingMonitorInjectJsTime(js_inject_msg);
    }

  bd_global.addEventListener( "DOMContentLoaded", onDomContentLoaded );

  function sendError(errorDic) {
    var eventValue = {}
    var category = errorDic.category;
    eventValue[category] = 1;
    var message = {}
    message.ev_type = category
    message.event = eventValue
    jsIESLiveTimingMonitorAccumulate(message, 'overview')
  }

  var addEventListener = bd_global.addEventListener;
  if (addEventListener) {
    bd_global.addEventListener('unhandledrejection', function (event) {
      if (event) {
        var reason = event.reason;
        sendError({
          title: 'unhandledrejection',
          msg:'unhandledrejection' + reason,
          category: 'js_error_count',
          level: 'error'
        });
      }
    }, true);
    bd_global.addEventListener('error', function (event) {
      if (event) {
        var target = event.target || event.srcElement;
        var isElementTarget = target instanceof HTMLElement;
        var url = target.src || target.href;
        if (!isElementTarget) {
          sendError({
            title:target.nodeName,
            msg:url,
            category:'js_error_count',
            level: 'error'
          });
        };
      }
    }, true);
  }

    console.log('current NavigationId = ', currentNaviID);
})()
